#include <stdio.h>
#define HEIGHT 8

int
main() 
{
  int size;
  char *fnt;
  char buf[256];
  FILE *fp;
  int fd;
  int code,xcode;
  int mode;
  int c;

  size = 32 + 1 * HEIGHT * 256 + 2 * HEIGHT * 8064;
  fnt = (char *)malloc(size);
  memset(fnt,0,size);
  mode = -2;
  fp = fopen("clR5x8.bdf","r");
  while (fgets(buf,256,fp) != NULL) {
    if (sscanf(buf,"ENCODING %d",&code)==1) {
    } else if (!strncmp(buf,"BITMAP",6)) {
      mode = -1;
    } else if (!strncmp(buf,"ENDCHAR",7)) {
      mode = -2;
    }
    if (mode >= 0 && sscanf(buf,"%x",&c) == 1) {
      fnt[32 + code * HEIGHT + mode] = c;
    }
    if (mode >= -1) mode ++;
  }
  fclose(fp);

  fp = fopen("elisau10.bdf","r");
  while (fgets(buf,256,fp) != NULL) {
    if (sscanf(buf,"STARTCHAR %x",&code)==1) {
      xcode = ((code & 0xff) - 0x20)
	+ (((code >> 8) & 0xff) - 0x21) * 96;
    } else if (!strncmp(buf,"BITMAP",6)) {
      mode = -1;
    } else if (!strncmp(buf,"ENDCHAR",7)) {
      mode = -2;
    }
    if (mode >= 0 && sscanf(buf,"%x",&c) == 1) {
      if (xcode < 8064) {
	fnt[32 + 256 * HEIGHT + xcode * HEIGHT * 2 + mode*2] = (c >> 8) & 0xff;
	fnt[32 + 256 * HEIGHT + xcode * HEIGHT * 2 + mode*2 + 1] = c & 0xff;
      }
    }
    if (mode >= -1) mode++;
  }
  fclose(fp);

  fd = creat("elisab10.fnt",0666);
  write(fd,fnt,size);
  close(fd);

  return 0;
}
